<?php
error_reporting(E_ALL);

// Example code that allows uploading of files to PHP.
// Requires a version of GameMaster that supports file uploads (at least 0.8).
// Copyright Martin Persson System & Design 2009
// View this file with tabstop=4, shiftwidth=4, or face the consequences.
// And if you use spaces for indentation, then you are simply WRONG.

print "Starting script...\n";

if ($argc < 3) {
	die("Usage: upload.php <local-filename> <remote-path>\n");
}

$data = file_get_contents($argv[1]);
if ($data === FALSE) {
	die("Error: Unable to open local file \"" . $argv[1] . "\n");
}

$data = base64_encode($data);

$command = array('command' => 'put',
		'path' => $argv[2],
		'contents' => $data,
		'username' => 'localadmin',
		'password' => 'secret');

$address = '127.0.0.1';
$port = 4554;

# We need to append a newline at the end to indicate to the Perl-based
# server that the input is ending.
$json_command = json_encode($command) . "\n";

print "Creating socket...\n";
if (($socket = socket_create(AF_INET, SOCK_STREAM,
		getprotobyname('tcp'))) === FALSE) {
	die("Unable to create TCP socket.\n");
}

print "Connecting to remote host $address on port $port...\n";
if (!socket_connect($socket, $address, $port)) {
	die("Unable to connect to remote host.\n");
}

print "Writing command to socket...\n";
if (($bytes_written = socket_write($socket, $json_command)) === FALSE) {
	die("Unable to write JSON encoded data to socket.\n");
}

print "Reading response from socket...\n";
if (($response_json = socket_read($socket, 2048, PHP_NORMAL_READ)) === FALSE) {
	die("Unable to read server response from socket.\n");
}
print "Closing socket...\n";
socket_close($socket);

# Remove trailing extra newline.
$response_json = chop($response_json);

$response = json_decode($response_json, true);

print "Server response: $response_json\n";

if ($response['status'] == 'error') {
	print "An error occured: \"" . $response['message'] . "\n";
} else {

	print "Response: " . $response . "\n";
}

?>

